#include <stdlib.h>
#include <errno.h>
#include <stdio.h>

static void print_usage(char** argv) {
  printf("Usage: %s <a_dim_i> <a_dim_j> <b_dim_i> <b_dim_j>\n", argv[0]);
}

static int try_parse_arg(char* string_value) {
  int v = (int) strtol(string_value, (char **) NULL, 10);
  if(errno == EINVAL || errno == ERANGE || v <= 0) {
    printf("Wrong argument specified (must be a valid integer > 0): %s\n", string_value);
    exit(2);
  }
  return v;
}

void parse_cmd(int argc, char** argv, int* dim_a_i, int* dim_a_j, int* dim_b_i, int* dim_b_j) {

  if( argc < 5 ) {
    printf("Wrong number of arguments specified.\n");
    print_usage(argv);
    exit(1);
  }

  // Try arguments parsing
  *dim_a_i = try_parse_arg(argv[1]);
  *dim_a_j = try_parse_arg(argv[2]);
  *dim_b_i = try_parse_arg(argv[3]);
  *dim_b_j = try_parse_arg(argv[4]);
  printf("parse_cmd: detected sizes a[%d][%d] and b[%d][%d]\n", *dim_a_i, *dim_a_j, *dim_b_i, *dim_b_j);
}
